// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A locality hint that can be used by the Batch service to select a compute node on which to start a new task.
    /// </summary>
    public partial class AffinityInformation : ITransportObjectProvider<Models.AffinityInformation>, IPropertyMetadata
    {
        private readonly string affinityId;

        #region Constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="AffinityInformation"/> class.
        /// </summary>
        /// <param name='affinityId'>An opaque string that represents a previously run task or compute node.</param>
        public AffinityInformation(
            string affinityId)
        {
            this.affinityId = affinityId;
        }

        internal AffinityInformation(Models.AffinityInformation protocolObject)
        {
            this.affinityId = protocolObject.AffinityId;
        }

        #endregion Constructors

        #region AffinityInformation

        /// <summary>
        /// Gets an opaque string that represents a previously run task or compute node.
        /// </summary>
        public string AffinityId
        {
            get { return this.affinityId; }
        }

        #endregion // AffinityInformation

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata

        #region Internal/private methods

        /// <summary>
        /// Return a protocol object of the requested type.
        /// </summary>
        /// <returns>The protocol object of the requested type.</returns>
        Models.AffinityInformation ITransportObjectProvider<Models.AffinityInformation>.GetTransportObject()
        {
            Models.AffinityInformation result = new Models.AffinityInformation()
            {
                AffinityId = this.AffinityId,
            };

            return result;
        }


        #endregion // Internal/private methods
    }
}