// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// An error message received in an Azure Batch error response.
    /// </summary>
    public partial class ErrorMessage
    {
        /// <summary>
        /// Initializes a new instance of the ErrorMessage class.
        /// </summary>
        public ErrorMessage() { }

        /// <summary>
        /// Initializes a new instance of the ErrorMessage class.
        /// </summary>
        /// <param name="lang">The language code of the error message</param>
        /// <param name="value">The text of the message.</param>
        public ErrorMessage(string lang = default(string), string value = default(string))
        {
            Lang = lang;
            Value = value;
        }

        /// <summary>
        /// Gets or sets the language code of the error message
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "lang")]
        public string Lang { get; set; }

        /// <summary>
        /// Gets or sets the text of the message.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

    }
}
