// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the content source.
    /// </summary>
    public partial class ContentSource
    {
        private ContentHash _contentHash;
        
        /// <summary>
        /// Optional. Gets or sets the hash.
        /// </summary>
        public ContentHash ContentHash
        {
            get { return this._contentHash; }
            set { this._contentHash = value; }
        }
        
        private string _contentType;
        
        /// <summary>
        /// Optional. Gets or sets the content source type.
        /// </summary>
        public string ContentType
        {
            get { return this._contentType; }
            set { this._contentType = value; }
        }
        
        private string _value;
        
        /// <summary>
        /// Optional. Gets or sets the value of the content. This is based on
        /// the content source type.
        /// </summary>
        public string Value
        {
            get { return this._value; }
            set { this._value = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets or sets the version of the content.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ContentSource class.
        /// </summary>
        public ContentSource()
        {
        }
    }
}
