// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// The parameters supplied to the start runbook operation.
    /// </summary>
    public partial class RunbookDraftUpdateParameters
    {
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the runbook name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _stream;
        
        /// <summary>
        /// Required. Gets or sets the content of the runbook version.
        /// </summary>
        public string Stream
        {
            get { return this._stream; }
            set { this._stream = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RunbookDraftUpdateParameters
        /// class.
        /// </summary>
        public RunbookDraftUpdateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the RunbookDraftUpdateParameters
        /// class with required arguments.
        /// </summary>
        public RunbookDraftUpdateParameters(string name, string stream)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (stream == null)
            {
                throw new ArgumentNullException("stream");
            }
            this.Name = name;
            this.Stream = stream;
        }
    }
}
