// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Batch.Models
{
    using System.Linq;

    /// <summary>
    /// A set of Azure Batch account keys.
    /// </summary>
    public partial class BatchAccountKeys
    {
        /// <summary>
        /// Initializes a new instance of the BatchAccountKeys class.
        /// </summary>
        public BatchAccountKeys() { }

        /// <summary>
        /// Initializes a new instance of the BatchAccountKeys class.
        /// </summary>
        /// <param name="primary">The primary key associated with the
        /// account.</param>
        /// <param name="secondary">The secondary key associated with the
        /// account.</param>
        public BatchAccountKeys(string primary = default(string), string secondary = default(string))
        {
            Primary = primary;
            Secondary = secondary;
        }

        /// <summary>
        /// Gets or sets the primary key associated with the account.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "primary")]
        public string Primary { get; set; }

        /// <summary>
        /// Gets or sets the secondary key associated with the account.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "secondary")]
        public string Secondary { get; set; }

    }
}
