// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The instance view of a virtual machine scale set.
    /// </summary>
    public partial class VirtualMachineScaleSetInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetInstanceView class.
        /// </summary>
        public VirtualMachineScaleSetInstanceView() { }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetInstanceView class.
        /// </summary>
        public VirtualMachineScaleSetInstanceView(VirtualMachineScaleSetInstanceViewStatusesSummary virtualMachine = default(VirtualMachineScaleSetInstanceViewStatusesSummary), IList<VirtualMachineScaleSetVMExtensionsSummary> extensions = default(IList<VirtualMachineScaleSetVMExtensionsSummary>), IList<InstanceViewStatus> statuses = default(IList<InstanceViewStatus>))
        {
            VirtualMachine = virtualMachine;
            Extensions = extensions;
            Statuses = statuses;
        }

        /// <summary>
        /// the instance view status summary for the virtual machine scale set.
        /// </summary>
        [JsonProperty(PropertyName = "virtualMachine")]
        public VirtualMachineScaleSetInstanceViewStatusesSummary VirtualMachine { get; private set; }

        /// <summary>
        /// the extensions information.
        /// </summary>
        [JsonProperty(PropertyName = "extensions")]
        public IList<VirtualMachineScaleSetVMExtensionsSummary> Extensions { get; private set; }

        /// <summary>
        /// the resource status information.
        /// </summary>
        [JsonProperty(PropertyName = "statuses")]
        public IList<InstanceViewStatus> Statuses { get; set; }

    }
}
