// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// Description of a service diagnostic setting
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class ServiceDiagnosticSettingsResource : Resource
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ServiceDiagnosticSettingsResource class.
        /// </summary>
        public ServiceDiagnosticSettingsResource() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ServiceDiagnosticSettingsResource class.
        /// </summary>
        /// <param name="location">Resource location</param>
        /// <param name="id">Azure resource Id</param>
        /// <param name="name">Azure resource name</param>
        /// <param name="type">Azure resource type</param>
        /// <param name="tags">Resource tags</param>
        /// <param name="storageAccountId">the resource id of the storage
        /// account.</param>
        /// <param name="serviceBusRuleId">the id of the service bus
        /// rule.</param>
        /// <param name="metrics">the list of metrics.</param>
        /// <param name="logs">the list of logs.</param>
        /// <param name="workspaceId">the OMS workspace Id.</param>
        public ServiceDiagnosticSettingsResource(string location, string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), string storageAccountId = default(string), string serviceBusRuleId = default(string), System.Collections.Generic.IList<MetricSettings> metrics = default(System.Collections.Generic.IList<MetricSettings>), System.Collections.Generic.IList<LogSettings> logs = default(System.Collections.Generic.IList<LogSettings>), string workspaceId = default(string))
            : base(location, id, name, type, tags)
        {
            StorageAccountId = storageAccountId;
            ServiceBusRuleId = serviceBusRuleId;
            Metrics = metrics;
            Logs = logs;
            WorkspaceId = workspaceId;
        }

        /// <summary>
        /// Gets or sets the resource id of the storage account.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.storageAccountId")]
        public string StorageAccountId { get; set; }

        /// <summary>
        /// Gets or sets the id of the service bus rule.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.serviceBusRuleId")]
        public string ServiceBusRuleId { get; set; }

        /// <summary>
        /// Gets or sets the list of metrics.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.metrics")]
        public System.Collections.Generic.IList<MetricSettings> Metrics { get; set; }

        /// <summary>
        /// Gets or sets the list of logs.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.logs")]
        public System.Collections.Generic.IList<LogSettings> Logs { get; set; }

        /// <summary>
        /// Gets or sets the OMS workspace Id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.workspaceId")]
        public string WorkspaceId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (this.Metrics != null)
            {
                foreach (var element in this.Metrics)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (this.Logs != null)
            {
                foreach (var element1 in this.Logs)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
