// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class WorkflowRunTrigger
    {
        /// <summary>
        /// Initializes a new instance of the WorkflowRunTrigger class.
        /// </summary>
        public WorkflowRunTrigger() { }

        /// <summary>
        /// Initializes a new instance of the WorkflowRunTrigger class.
        /// </summary>
        public WorkflowRunTrigger(string name = default(string), object inputs = default(object), ContentLink inputsLink = default(ContentLink), object outputs = default(object), ContentLink outputsLink = default(ContentLink), DateTime? startTime = default(DateTime?), DateTime? endTime = default(DateTime?), string trackingId = default(string), Correlation correlation = default(Correlation), string code = default(string), WorkflowStatus? status = default(WorkflowStatus?), object error = default(object), object trackedProperties = default(object))
        {
            Name = name;
            Inputs = inputs;
            InputsLink = inputsLink;
            Outputs = outputs;
            OutputsLink = outputsLink;
            StartTime = startTime;
            EndTime = endTime;
            TrackingId = trackingId;
            Correlation = correlation;
            Code = code;
            Status = status;
            Error = error;
            TrackedProperties = trackedProperties;
        }

        /// <summary>
        /// Gets gets the name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets gets the inputs.
        /// </summary>
        [JsonProperty(PropertyName = "inputs")]
        public object Inputs { get; private set; }

        /// <summary>
        /// Gets gets the link to inputs.
        /// </summary>
        [JsonProperty(PropertyName = "inputsLink")]
        public ContentLink InputsLink { get; private set; }

        /// <summary>
        /// Gets gets the outputs.
        /// </summary>
        [JsonProperty(PropertyName = "outputs")]
        public object Outputs { get; private set; }

        /// <summary>
        /// Gets gets the link to outputs.
        /// </summary>
        [JsonProperty(PropertyName = "outputsLink")]
        public ContentLink OutputsLink { get; private set; }

        /// <summary>
        /// Gets gets the start time.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets gets the end time.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets gets the tracking id.
        /// </summary>
        [JsonProperty(PropertyName = "trackingId")]
        public string TrackingId { get; private set; }

        /// <summary>
        /// Gets or sets gets or sets the run correlation.
        /// </summary>
        [JsonProperty(PropertyName = "correlation")]
        public Correlation Correlation { get; set; }

        /// <summary>
        /// Gets gets the code.
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; private set; }

        /// <summary>
        /// Gets gets the status. Possible values include: 'NotSpecified',
        /// 'Paused', 'Running', 'Waiting', 'Succeeded', 'Skipped',
        /// 'Suspended', 'Cancelled', 'Failed', 'Faulted', 'TimedOut',
        /// 'Aborted', 'Ignored'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public WorkflowStatus? Status { get; private set; }

        /// <summary>
        /// Gets gets the error.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public object Error { get; private set; }

        /// <summary>
        /// Gets gets the tracked properties.
        /// </summary>
        [JsonProperty(PropertyName = "trackedProperties")]
        public object TrackedProperties { get; private set; }

    }
}
