// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class X12FramingSettings
    {
        /// <summary>
        /// Initializes a new instance of the X12FramingSettings class.
        /// </summary>
        public X12FramingSettings() { }

        /// <summary>
        /// Initializes a new instance of the X12FramingSettings class.
        /// </summary>
        public X12FramingSettings(int? dataElementSeparator = default(int?), int? componentSeparator = default(int?), bool? replaceSeparatorsInPayload = default(bool?), int? replaceCharacter = default(int?), int? segmentTerminator = default(int?), X12CharacterSet? characterSet = default(X12CharacterSet?), SegmentTerminatorSuffix? segmentTerminatorSuffix = default(SegmentTerminatorSuffix?))
        {
            DataElementSeparator = dataElementSeparator;
            ComponentSeparator = componentSeparator;
            ReplaceSeparatorsInPayload = replaceSeparatorsInPayload;
            ReplaceCharacter = replaceCharacter;
            SegmentTerminator = segmentTerminator;
            CharacterSet = characterSet;
            SegmentTerminatorSuffix = segmentTerminatorSuffix;
        }

        /// <summary>
        /// Gets or sets the data element separator.
        /// </summary>
        [JsonProperty(PropertyName = "dataElementSeparator")]
        public int? DataElementSeparator { get; set; }

        /// <summary>
        /// Gets or sets the component separator.
        /// </summary>
        [JsonProperty(PropertyName = "componentSeparator")]
        public int? ComponentSeparator { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to replace separators in
        /// payload.
        /// </summary>
        [JsonProperty(PropertyName = "replaceSeparatorsInPayload")]
        public bool? ReplaceSeparatorsInPayload { get; set; }

        /// <summary>
        /// Gets or sets the replacement character.
        /// </summary>
        [JsonProperty(PropertyName = "replaceCharacter")]
        public int? ReplaceCharacter { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator.
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminator")]
        public int? SegmentTerminator { get; set; }

        /// <summary>
        /// Gets or sets the X12 character set. Possible values include:
        /// 'NotSpecified', 'Basic', 'Extended', 'UTF8'
        /// </summary>
        [JsonProperty(PropertyName = "characterSet")]
        public X12CharacterSet? CharacterSet { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator suffix. Possible values
        /// include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminatorSuffix")]
        public SegmentTerminatorSuffix? SegmentTerminatorSuffix { get; set; }

    }
}
