// Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.TrafficManager.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Class representing a Traffic Manager profile.
    /// </summary>
    [JsonTransformation]
    public partial class Profile : Resource
    {
        /// <summary>
        /// Initializes a new instance of the Profile class.
        /// </summary>
        public Profile() { }

        /// <summary>
        /// Initializes a new instance of the Profile class.
        /// </summary>
        public Profile(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string profileStatus = default(string), string trafficRoutingMethod = default(string), DnsConfig dnsConfig = default(DnsConfig), MonitorConfig monitorConfig = default(MonitorConfig), IList<Endpoint> endpoints = default(IList<Endpoint>))
            : base(id, name, type, location, tags)
        {
            ProfileStatus = profileStatus;
            TrafficRoutingMethod = trafficRoutingMethod;
            DnsConfig = dnsConfig;
            MonitorConfig = monitorConfig;
            Endpoints = endpoints;
        }

        /// <summary>
        /// Gets or sets the status of the Traffic Manager profile.  Possible
        /// values are 'Enabled' and 'Disabled'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.profileStatus")]
        public string ProfileStatus { get; set; }

        /// <summary>
        /// Gets or sets the traffic routing method of the Traffic Manager
        /// profile.  Possible values are 'Performance', 'Weighted', or
        /// 'Priority'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.trafficRoutingMethod")]
        public string TrafficRoutingMethod { get; set; }

        /// <summary>
        /// Gets or sets the DNS settings of the Traffic Manager profile.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dnsConfig")]
        public DnsConfig DnsConfig { get; set; }

        /// <summary>
        /// Gets or sets the endpoint monitoring settings of the Traffic
        /// Manager profile.
        /// </summary>
        [JsonProperty(PropertyName = "properties.monitorConfig")]
        public MonitorConfig MonitorConfig { get; set; }

        /// <summary>
        /// Gets or sets the list of endpoints in the Traffic Manager profile.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endpoints")]
        public IList<Endpoint> Endpoints { get; set; }

    }
}
