// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Single sign on request information for domain management
    /// </summary>
    public partial class DomainControlCenterSsoRequest
    {
        /// <summary>
        /// Initializes a new instance of the DomainControlCenterSsoRequest
        /// class.
        /// </summary>
        public DomainControlCenterSsoRequest() { }

        /// <summary>
        /// Initializes a new instance of the DomainControlCenterSsoRequest
        /// class.
        /// </summary>
        public DomainControlCenterSsoRequest(string url = default(string), string postParameterKey = default(string), string postParameterValue = default(string))
        {
            Url = url;
            PostParameterKey = postParameterKey;
            PostParameterValue = postParameterValue;
        }

        /// <summary>
        /// Url where the single sign on request is to be made
        /// </summary>
        [JsonProperty(PropertyName = "url")]
        public string Url { get; set; }

        /// <summary>
        /// Post parameter key
        /// </summary>
        [JsonProperty(PropertyName = "postParameterKey")]
        public string PostParameterKey { get; set; }

        /// <summary>
        /// Post parameter value. Client should use
        /// 'application/x-www-form-urlencoded' encoding for this value.
        /// </summary>
        [JsonProperty(PropertyName = "postParameterValue")]
        public string PostParameterValue { get; set; }

    }
}
