// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Describes the source control configuration for web app
    /// </summary>
    public partial class SiteSourceControl : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SiteSourceControl class.
        /// </summary>
        public SiteSourceControl() { }

        /// <summary>
        /// Initializes a new instance of the SiteSourceControl class.
        /// </summary>
        public SiteSourceControl(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string repoUrl = default(string), string branch = default(string), bool? isManualIntegration = default(bool?), bool? deploymentRollbackEnabled = default(bool?), bool? isMercurial = default(bool?))
            : base(location, id, name, type, tags)
        {
            RepoUrl = repoUrl;
            Branch = branch;
            IsManualIntegration = isManualIntegration;
            DeploymentRollbackEnabled = deploymentRollbackEnabled;
            IsMercurial = isMercurial;
        }

        /// <summary>
        /// Repository or source control url
        /// </summary>
        [JsonProperty(PropertyName = "properties.repoUrl")]
        public string RepoUrl { get; set; }

        /// <summary>
        /// Name of branch to use for deployment
        /// </summary>
        [JsonProperty(PropertyName = "properties.branch")]
        public string Branch { get; set; }

        /// <summary>
        /// Whether to manual or continuous integration
        /// </summary>
        [JsonProperty(PropertyName = "properties.isManualIntegration")]
        public bool? IsManualIntegration { get; set; }

        /// <summary>
        /// Whether to manual or continuous integration
        /// </summary>
        [JsonProperty(PropertyName = "properties.deploymentRollbackEnabled")]
        public bool? DeploymentRollbackEnabled { get; set; }

        /// <summary>
        /// Mercurial or Git repository type
        /// </summary>
        [JsonProperty(PropertyName = "properties.isMercurial")]
        public bool? IsMercurial { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
