// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Truncates the terms to a specific length. This token filter is
    /// implemented using Apache Lucene.
    /// <see href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/miscellaneous/TruncateTokenFilter.html" />
    /// </summary>
    [JsonObject("#Microsoft.Azure.Search.TruncateTokenFilter")]
    public partial class TruncateTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the TruncateTokenFilter class.
        /// </summary>
        public TruncateTokenFilter() { }

        /// <summary>
        /// Initializes a new instance of the TruncateTokenFilter class.
        /// </summary>
        public TruncateTokenFilter(string name, int? length = default(int?))
            : base(name)
        {
            Length = length;
        }

        /// <summary>
        /// Gets or sets the length at which terms will be truncated. Default
        /// is 300.
        /// </summary>
        [JsonProperty(PropertyName = "length")]
        public int? Length { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
